//
// PS2PC: An Intel x86 emulator for MIPS R5900 (Sony PS2).
// Coded by Mike Tedder / breakpoint - bpoint@parodius.com
// http://ps2pc.parodius.com
//
// This project is released as 'open source'.  You may make any modifications
// or adjustments to the code and submit a patch to be applied to the project.
// See the web page for more details.
//
//-----------------------------------------------------------------------

#include "types.h"
#include "r59basic.h"


ulong r5900ADDI(uchar rt, uchar rs, ushort immed)
{
	return (0x08 << 26) | (rs << 21) | (rt << 16) | immed;
}

ulong r5900ADDIU(uchar rt, uchar rs, ushort immed)
{
	return (0x09 << 26) | (rs << 21) | (rt << 16) | immed;
}

ulong r5900OR(uchar rd, uchar rs, uchar rt)
{
	return (rs << 21) | (rt << 16) | (rd << 11) | 0x25;
}

ulong r5900ORI(uchar rt, uchar rs, ushort immed)
{
	return (0x0D << 26) | (rs << 21) | (rt << 16) | immed;
}

ulong r5900AND(uchar rd, uchar rs, uchar rt)
{
	return (rs << 21) | (rt << 16) | (rd << 11) | 0x24;
}

ulong r5900ANDI(uchar rt, uchar rs, ushort immed)
{
	return (0x0C << 26) | (rs << 21) | (rt << 16) | immed;
}

ulong r5900LUI(uchar rt, ushort immed)
{
	return (0x0F << 26) | (rt << 16) | immed;
}

ulong r5900SLL(uchar rd, uchar rt, uchar sa)
{
	return (rt << 16) | (rd << 11) | (sa << 6);
}

